------------------------------------------------+
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
------------------------------------------------+
entity  BotIncrement is
Port (
		BotUp:          in   std_logic;
		BotDown:        in   std_logic;
		ClkIn:          in   std_logic;
		BotPosition:    out  integer range 0 to 4095 :=2047
      );
end BotIncrement;
------------------------------------------------+
architecture G of BotIncrement is
--===============================================
	signal Mat,Math:            integer :=0;
	signal R:                   integer :=2047;
--===============================================
BEGIN


------------------------------------------------+
process (ClkIn)
begin
if ClkIn'event and ClkIn='1' then
----------------------------------+
case Mat is
        -------------------------------------+
        when 0 => if BotUp = '1' then Mat<=1;
                                      R<=R+10;
                                 else Mat<=0;
                                 end if;
        -------------------------------------+
        when 1 => if BotUp = '0' then  Mat<=0;
                                 end if;
        -------------------------------------+
        when others =>Mat<=0;
end case;
----------------------------------+
case Math is
        -------------------------------------+
        when 0 => if BotDown = '1' then Math<=1;
                                        R<=R-10;
                                   end if;
        -------------------------------------+
        when 1 => if BotDown = '0' then  Math<=0;
                                   end if;
        -------------------------------------+
        when others =>Math<=0;
end case;
---------------------------------+
BotPosition<=R;
---------------------------------+
end if;
end process;
------------------------------------------------+



end architecture G;