-------------------------------------------------------------------------------------------------+
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
-------------------------------------------------------------------------------------------------+
entity  DividerCLK is

generic(CLK_In_Hz:      integer range 1 to 100000000 := 80000000;
        CLK_Out_Hz:     integer range 1 to 100000000 := 2);
------------------------------------------------------------------
Port   (CLK:            in   std_logic :='0';
		CLK_OUT:        out  std_logic :='0');
		
end DividerCLK;
-------------------------------------------------------------------------------------------------+
architecture G of DividerCLK is
--=======================================================================
    signal C:           integer range 0 to CLK_In_Hz :=0;
--================================================================================================
BEGIN


-------------------------------------------------------------------------------------------------+
process(CLK)
begin
if CLK'Event and CLK='1' then
---Sintezator---------------------+
   if C >= (CLK_In_Hz-1)                
      then C <= (C - CLK_In_Hz);
elsif C >= 0 and C <= ((CLK_In_Hz/2)-1) 
      then CLK_OUT <= '1';
           C <=  C + CLK_Out_Hz;--one step = 1Hz;
      else CLK_OUT <= '0';
           C <=  C + CLK_Out_Hz;--one step = 1Hz;
      end if;
----------------------------------+
end if;
end process;
-------------------------------------------------------------------------------------------------+



end architecture G;