-------------------------------------------------------------------------+
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
-------------------------------------------------------------------------+
entity  KeyDriver is
Port (
		KeyIn:          in  unsigned(4 downto 0):="00000";
		Clk16MHz:       in  std_logic;
		KeyOut:         out unsigned(4 downto 0):="00000"
      );
end KeyDriver;
-------------------------------------------------------------------------+
architecture G of KeyDriver is
--=======================================================================
	signal N,Mat:           integer  :=0;
	---------------------------------------------------------------------
	signal KeyTmp,KeyInTmp: unsigned(4 downto 0):="00000";
--=======================================================================
BEGIN


--------------------------------------------------------------------------+
process(Clk16MHz)
begin
if Clk16MHz'Event and Clk16MHz='1' then
----------------------------------+
KeyInTmp<=not(KeyIn);
----------------------------------+
case Mat is
        -------------------------------------+
        when 0 => if KeyInTmp>"00000"     then Mat<=1;
                                               N<=0;
                                               KeyOut<="00000";
                                               KeyTmp<=KeyInTmp;
                                          else Mat<=0;
                                          end if;
        -------------------------------------+
        when 1 => if N >= 5000000  then Mat<=0;
                                        N<=0;
                                        KeyOut<="00000";
               elsif N <= 2500000  then N<=N+1;
                                        KeyOut<=KeyTmp;
                                   else N<=N+1;
                                        KeyOut<="00000";
                                   end if;
        -------------------------------------+
        when others =>Mat<=0;
end case;
----------------------------------+
end if;
end process;
---------------------------------------------------------------------------+


end architecture G;